<template>
  <Row class="stock-head">
    <i-col class="left-head head-wrapper" :span="12">
      <div class="div-btn info-hover" @click="collapsedEmitAction()">
        <Icon type="md-menu" size="32" />
      </div>
      <div class="stock-blog-logo inline-block">
        <nuxt-link to="/">STOCK-BLOG</nuxt-link>
      </div>
    </i-col>
    <i-col class="right-head head-wrapper" :span="12">
      <div class="user-info-box" :style="userInfoStyle">
        <Row :gutter="8">
          <i-col class="user-info-item" :lg="24" :md="24" title="LOG OUT" @click.native="logoutAction">
            <div class="user-info-item-icon">
              <Icon type="md-log-out" size="28" />
            </div>
            <div class="user-info-item-name overflow-dot">
              LOG OUT
            </div>
          </i-col>
        </Row>
      </div>
      <div class="user inline-block float-right pointer" :style="{backgroundImage}" @click="displayUserInfoBoxAction"></div>
    </i-col>
  </Row>
</template>

<script>
import { mapGetters, mapActions } from 'vuex';
import { validators as api } from '../configs/request-validator/user';

const actions = {
  collapsedEmitAction() {
    this.$emit('input', !this.value);
  },
  displayUserInfoBoxAction() {
    this.setDisplayUserInfoBox();
  },
  switchThemeAction() {
    const themeGoingToUse = (this.theme === 'light-theme') ? 'night-theme' : 'light-theme';
    this.setDisplayUserInfoBox(false);
    this.setTheme(themeGoingToUse);
  },
  redirectProfileAction() {
    this.setDisplayUserInfoBox(false);
    const redirectRouteName = (this.routeName.includes('manager'))
      ? 'manager-personal'
      : 'investor-personal';
    this.$redirectTo(redirectRouteName);
  },
  async logoutAction() {
    try {
      const { status, code } = await this.$api(api.LogoutRequest, {});
      const logoutSuccess = status && code === 200;
      if (logoutSuccess) {
        this.setDisplayUserInfoBox(false);
        this.removeToken();
        this.removeUser();
        this.clearCompanies();
        this.$redirectTo('index');
      }
    } catch (error) {
      this.$apiErrorHandler(error);
    }
  },
};

export default {
  name: 'stock-head',
  props: {
    value: {
      type: Boolean,
      required: true,
    },
  },
  data() {
    return {
      userInfoBoxIsOpened: false,
    };
  },
  computed: {
    ...mapGetters(['theme']),
    ...mapGetters('user', ['user']),
    ...mapGetters('view', ['displayUserInfoBox']),
    userInfoStyle() {
      return (this.displayUserInfoBox) ? {
          top: '70px',
          zIndex: '900',
          opacity: '1',
        }
        : {
          top: '30px',
          zIndex: '-1',
          opacity: '0',
        };
    },
    routeName() {
      return this.$route.name;
    },
    backgroundImage() {
      return `url("${this.user.image}")`;
    }
  },
  methods: {
    ...mapActions(['setTheme', 'removeToken']),
    ...mapActions('user', ['removeUser']),
    ...mapActions('view', ['setDisplayUserInfoBox']),
    ...mapActions('company', ['clearCompanies']),
    ...actions,
  }
}
</script>


<style lang="scss" scoped>
  .stock-head {
    height: 60px;
    padding: 10px 40px;
    .head-wrapper {
      height: 40px;
      line-height: 40px;
      vertical-align: middle;
    }
    .left-head {
      .stock-blog-logo {
        margin: 0 10px;
      }
    }
    .right-head {
      .user-info-box {
        position: absolute;
        right: 0;
        width: 150px;
        padding: 15px;
        border-radius: 4px;
        z-index: 900;
        transition: top 0.5s linear, opacity 0.6s linear, z-index 0.8s linear;
        .user-info-item {
          line-height: 1;
          text-align: center;
          padding: 10px;
          vertical-align: middle;
          cursor: pointer;
          .user-info-item-icon {
            display: inline-block;
            width: 40px;
            height: 40px;
            border-radius: 4px;;
            text-align: center;
            line-height: 40px;
            vertical-align: middle;
            margin-bottom: 10px;
          }
        }
      }
      .user {
        width: 40px;
        height: 40px;
        border-radius: 21px;
        margin-left: 30px;
        background-size: cover;
        transition: box-shadow 0.2s;
      }
    }
  }
</style>

